"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireDefault(require("react"));
var _email_pane = _interopRequireDefault(require("../../field/email/email_pane"));
var _password_pane = _interopRequireDefault(require("../../field/password/password_pane"));
var _username_pane = _interopRequireDefault(require("../../field/username/username_pane"));
var _custom_input = _interopRequireDefault(require("../../field/custom_input"));
var _index = require("../../connection/database/index");
var _captcha_pane = _interopRequireDefault(require("../../field/captcha/captcha_pane"));
var l = _interopRequireWildcard(require("../../core/index"));
var _captcha = require("../../connection/captcha");
var _enterprise = require("../../connection/enterprise");
var _classic = require("../classic");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _callSuper(t, o, e) { return o = _getPrototypeOf(o), _possibleConstructorReturn(t, _isNativeReflectConstruct() ? Reflect.construct(o, e || [], _getPrototypeOf(t).constructor) : o.apply(t, e)); }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
var SignUpPane = exports.default = /*#__PURE__*/function (_React$Component) {
  function SignUpPane() {
    _classCallCheck(this, SignUpPane);
    return _callSuper(this, SignUpPane, arguments);
  }
  _inherits(SignUpPane, _React$Component);
  return _createClass(SignUpPane, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
        emailInputPlaceholder = _this$props.emailInputPlaceholder,
        instructions = _this$props.instructions,
        i18n = _this$props.i18n,
        model = _this$props.model,
        onlyEmail = _this$props.onlyEmail,
        passwordInputPlaceholder = _this$props.passwordInputPlaceholder,
        passwordStrengthMessages = _this$props.passwordStrengthMessages,
        usernameInputPlaceholder = _this$props.usernameInputPlaceholder;
      var headerText = instructions || null;
      var header = headerText && /*#__PURE__*/_react.default.createElement("p", null, headerText);
      var sso = (0, _classic.isSSOEnabled)(model);
      var usernamePane = !onlyEmail && (0, _index.databaseConnectionRequiresUsername)(model) && !(0, _index.signUpHideUsernameField)(model) ? /*#__PURE__*/_react.default.createElement(_username_pane.default, {
        i18n: i18n,
        lock: model,
        placeholder: usernameInputPlaceholder,
        validateFormat: true,
        strictValidation: (0, _index.signUpFieldsStrictValidation)(model)
      }) : null;
      var fields = !onlyEmail && (0, _index.additionalSignUpFields)(model).map(function (x) {
        return /*#__PURE__*/_react.default.createElement(_custom_input.default, {
          iconUrl: x.get('icon'),
          key: x.get('name'),
          model: model,
          name: x.get('name'),
          ariaLabel: x.get('ariaLabel'),
          options: x.get('options'),
          placeholder: x.get('placeholder'),
          placeholderHTML: x.get('placeholderHTML'),
          type: x.get('type'),
          validator: x.get('validator'),
          value: x.get('value')
        });
      });
      var captchaPane = l.captcha(model) && l.captcha(model).get('required') && ((0, _enterprise.isHRDDomain)(model, (0, _index.databaseUsernameValue)(model)) || !sso) ? /*#__PURE__*/_react.default.createElement(_captcha_pane.default, {
        i18n: i18n,
        lock: model,
        onReload: function onReload() {
          return (0, _captcha.swapCaptcha)(l.id(model), _captcha.Flow.DEFAULT, false);
        }
      }) : null;
      var passwordPane = !onlyEmail && /*#__PURE__*/_react.default.createElement(_password_pane.default, {
        i18n: i18n,
        lock: model,
        placeholder: passwordInputPlaceholder,
        policy: (0, _index.passwordStrengthPolicy)(model),
        strengthMessages: passwordStrengthMessages
      });
      return /*#__PURE__*/_react.default.createElement("div", null, header, /*#__PURE__*/_react.default.createElement(_email_pane.default, {
        i18n: i18n,
        lock: model,
        placeholder: emailInputPlaceholder,
        strictValidation: (0, _index.signUpFieldsStrictValidation)(model)
      }), usernamePane, passwordPane, fields, captchaPane);
    }
  }]);
}(_react.default.Component);
