"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _captcha_input = _interopRequireDefault(require("../../ui/input/captcha_input"));
var l = _interopRequireWildcard(require("../../core/index"));
var _index2 = require("../../store/index");
var captchaField = _interopRequireWildcard(require("../captcha"));
var _index3 = require("../index");
var _third_party_captcha = require("./third_party_captcha");
var _captcha2 = require("../../connection/captcha");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _callSuper(t, o, e) { return o = _getPrototypeOf(o), _possibleConstructorReturn(t, _isNativeReflectConstruct() ? Reflect.construct(o, e || [], _getPrototypeOf(t).constructor) : o.apply(t, e)); }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); } /* eslint-disable no-nested-ternary */
var CaptchaPane = exports.default = /*#__PURE__*/function (_React$Component) {
  function CaptchaPane() {
    _classCallCheck(this, CaptchaPane);
    return _callSuper(this, CaptchaPane, arguments);
  }
  _inherits(CaptchaPane, _React$Component);
  return _createClass(CaptchaPane, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
        i18n = _this$props.i18n,
        lock = _this$props.lock,
        onReload = _this$props.onReload,
        flow = _this$props.flow;
      var lockId = l.id(lock);
      var captcha = (0, _captcha2.getCaptchaConfig)(lock, flow);
      var value = (0, _index3.getFieldValue)(lock, 'captcha');
      var isValid = !(0, _index3.isFieldVisiblyInvalid)(lock, 'captcha');
      var provider = captcha.get('provider');
      if ((0, _third_party_captcha.isThirdPartyCaptcha)(provider)) {
        function handleChange(value) {
          (0, _index2.swap)(_index2.updateEntity, 'lock', lockId, captchaField.set, value);
        }
        function reset() {
          handleChange();
        }
        return /*#__PURE__*/_react.default.createElement(_third_party_captcha.ThirdPartyCaptcha, {
          provider: provider,
          sitekey: captcha.get('siteKey'),
          clientSubdomain: captcha.get('clientSubdomain'),
          onChange: handleChange,
          onExpired: reset,
          hl: l.ui.language(lock),
          isValid: isValid,
          value: value
        });
      }
      function handleChange(e) {
        (0, _index2.swap)(_index2.updateEntity, 'lock', lockId, captchaField.set, e.target.value);
      }
      var placeholder = captcha.get('type') === 'code' ? i18n.str("captchaCodeInputPlaceholder") : i18n.str("captchaMathInputPlaceholder");

      // TODO: blankErrorHint is deprecated.
      // It is kept for backwards compatibility in the code for the customers overwriting
      // it with languageDictionary. It can be removed in the next major release.
      return /*#__PURE__*/_react.default.createElement(_captcha_input.default, {
        lockId: lockId,
        image: captcha.get('image'),
        placeholder: placeholder,
        isValid: isValid,
        onChange: handleChange,
        onReload: onReload,
        value: value,
        invalidHint: i18n.str('blankErrorHint') || i18n.str('blankCaptchaErrorHint')
      });
    }
  }]);
}(_react.default.Component);
CaptchaPane.propTypes = {
  i18n: _propTypes.default.object.isRequired,
  lock: _propTypes.default.object.isRequired,
  error: _propTypes.default.bool,
  onReload: _propTypes.default.func.isRequired,
  flow: _propTypes.default.string,
  isPasswordReset: _propTypes.default.bool
};
CaptchaPane.defaultProps = {
  error: false
};
